image: node:14

variables:
  GITLAB_NPM_TOKEN: ${CI_JOB_TOKEN}

stages:
  - build
  - deploy

build:
  stage: build
  script:
    - npm ci
    - npm run build
  cache:
    key: $CI_COMMIT_REF_SLUG
    untracked: true
    policy: push

deploy:
  stage: deploy
  cache:
    key: $CI_COMMIT_REF_SLUG
    untracked: true
    policy: pull
  only:
    refs:
      - main
  script:
    - NPM_PACKAGE_NAME=$(node -p "require('./package.json').name")
    - NPM_PACKAGE_VERSION=$(node -p "require('./package.json').version")
    - npm config set @telosid:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PUBLIC_PROJECT_ID}/packages/npm/
    - npm config set -- //${CI_SERVER_HOST}/api/v4/projects/${CI_PUBLIC_PROJECT_ID}/packages/npm/:_authToken "${CI_JOB_TOKEN}"
    - |
      {
        npm publish &&
        echo "Successfully published version ${NPM_PACKAGE_VERSION} of ${NPM_PACKAGE_NAME} to GitLab's NPM registry: ${CI_PROJECT_URL}/-/packages"
      } || {
        echo "No new version of ${NPM_PACKAGE_NAME} published. This is most likely because version ${NPM_PACKAGE_VERSION} already exists in GitLab's NPM registry." &&
        exit 1
      }
